local hcTk = HCToolkit
local GetNumGroupMembers = GetNumGroupMembers
local NotifyInspect = NotifyInspect

function hcTk.GroupInit()
    hcTk.Group = {}
    hcTk.GroupKeys = {}
    hcTk.PlayerGUID = UnitGUID("player")
end

function hcTk.GroupFill()
    local group = hcTk.Group
    local groupKeys = hcTk.GroupKeys
    local members = GetNumGroupMembers()
    local prefix = hcTk.GroupTypeText()

    for i = 1, members do
        local unit = prefix .. i
        if (i == members and prefix == "party") then
            unit = 'player'
        end
        local guid = UnitGUID(unit)
        group[guid] = hcTk.UnitCreatePlayer(unit)
        groupKeys[i] = guid
  end
end

function hcTk.GroupUpdate()
    local newGroup = {}
    local newGroupKeys = {}
    local members = GetNumGroupMembers()
    local prefix = hcTk.GroupTypeText()

    for i = 1, members do
        unit = prefix .. i;
        if (i == members and prefix == "party") then
            unit = 'player';
        end

        local guid = UnitGUID(unit);
        if (hcTk.Group[guid] ~= nil) then
            newGroup[guid] = hcTk.Group[guid]
            newGroup[guid]["unit"] = unit
        else
            newGroup[guid] = hcTk.UnitCreatePlayer(unit)
        end
        newGroupKeys[i] = guid
    end

    hcTk.Group = newGroup
    hcTk.GroupKeys = newGroupKeys
end

function hcTk.GroupUpdateValues()
    for guid, player in pairs(hcTk.Group) do
        hcTk.UnitUpdateInformation(player)
    end
end

function hcTk.GroupTypeText()
    if IsInRaid() then
        return "raid"
    else
        return "party"
    end
end

function hcTk.GroupNameToGUIDs(group)
    local newGroup = {}
    for k, name in ipairs(group) do
        for guid, player in pairs(HCToolkit.Group) do
            if (player["name"] == name) then
                newGroup[#newGroup + 1] = guid
            end
        end
    end
    return newGroup
end